=== debian/changelog ===
solvespace (2.1+repack2-1build1) zesty; urgency=medium

  * No-change rebuild against latest glew

 -- Jeremy Bicha <jbicha@ubuntu.com>  Sun, 06 Nov 2016 22:07:05 -0500

solvespace (2.1+repack2-1) unstable; urgency=medium

  * Initial Release. (Closes: #797997)

 -- Anton Gladky <gladk@debian.org>  Mon, 15 Aug 2016 22:31:44 +0200
