## solvespace 2.3+repack1

=== CMakeLists.txt ===
--- 
+++ 
@@ -17,11 +17,16 @@
 
 # project
 
+# NOTE TO PACKAGERS: The embedded git commit hash is critical for rapid bug triage when the builds
+# can come from a variety of sources. If you are mirroring the sources or otherwise build when
+# the .git directory is not present, please comment the following line:
 include(GetGitCommitHash)
+# and instead uncomment the following, adding the complete git hash of the checkout you are using:
+# set(GIT_COMMIT_HASH 0000000000000000000000000000000000000000)
 
 project(solvespace)
 set(solvespace_VERSION_MAJOR 2)
-set(solvespace_VERSION_MINOR 1)
+set(solvespace_VERSION_MINOR 3)
 string(SUBSTRING "${GIT_COMMIT_HASH}" 0 8 solvespace_GIT_HASH)
 
 if(NOT WIN32 AND NOT APPLE)
