=== debian/changelog ===
solvespace (2.3+repack1-4build1) groovy; urgency=medium

  * No change rebuild against new json-c ABI.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 28 Jul 2020 17:48:05 +0100

solvespace (2.3+repack1-4) unstable; urgency=medium

  * [f5f8b5c] Add link to the fixed by upstream issue
  * [4ac4b71] Use secure URI in Homepage field.
  * [ef3f5da] Bump debhelper from old 10 to 13.
  * [047d9c4] Set debhelper-compat version in Build-Depends.
  * [8b28a26] Set upstream metadata fields: Bug-Database, Bug-Submit.
  * [fba85d0] Update Vcs-* headers from URL redirect.
  * [ab740f9] Use canonical URL in Vcs-Git.
  * [84a98ae] Replace libglu-dev by libglu1-mesa-dev in BD
  * [fdf3c0d] Set Standards-version to 4.5.0. No changes
  * [cefcb01] Set Rules-Requires-Root: no
  * [9869a0d] Add .gitlab-ci.yml
  * [53ab556] Install usr/share/pixmaps

 -- Anton Gladky <gladk@debian.org>  Mon, 01 Jun 2020 22:17:17 +0200

solvespace (2.3+repack1-3) unstable; urgency=medium

  * [6d84f29] Set minimal cmake version to 3.1.0.
  * [be690c9] Fix FTBFS with glibc 2.25. (Closes: #882167)
  * [6c8697c] Set Standards-Version: 4.1.1
  * [2c3d9bd] Set compat level 10
  * [fb232b5] Set maximal hardening options

 -- Anton Gladky <gladk@debian.org>  Wed, 22 Nov 2017 09:54:12 +0100

solvespace (2.3+repack1-2) unstable; urgency=medium

  * [0d4dc2b] Add missing dependency on libslvs1. (Closes: #856937)

 -- Anton Gladky <gladk@debian.org>  Mon, 06 Mar 2017 20:59:20 +0100

solvespace (2.3+repack1-1) unstable; urgency=medium

  * [a7825d4] Add d/watch.
  * [15facd8] Update get_orig.sh script.
  * [4bcf775] New upstream version 2.3+repack1
  * [5bfcd9a] Refresh patch.

 -- Anton Gladky <gladk@debian.org>  Sat, 31 Dec 2016 09:54:59 +0100
